/*
 * File: F28M35H52C1_Config.h
 */

#ifndef __F28M35H52C1_CONFIG_H__
#define __F28M35H52C1_CONFIG_H__

#ifdef __cplusplus
extern "C" {
#endif

#define F28M35H52C1_CFG_SYSPLLEN_VAL                    ( 0x00000002 )  // SYSTEM PLL ENABLED

/*
 * The maximum PLLSYSCLK is 150 MHz
 * The maximum frequency at which the Cortex-M3 core can run is 100 MHz.
 * This configuration configures M3SSCLK at 75 MHz for a 20 MHz OSSCLK input
 */
#define F28M35H52C1_CFG_PLLSYSCLK_HZ                    ( 150000000 )

/*
 * See Page 226 in the Concerto F28M28x TRM
 * PLLCLK = ( OSCCLK x SYSPLLMULT ) / 2
 */
#define F28M35H52C1_CFG_SYSPLLMULT_VAL                  ( 0x0F )    // Multiply by 15


/*
 * See page 226 in the Concerto F28M28x TRM
 * PLLSYSCLK = ( ( OSCCLK x SYSPLLMULT ) / ( 2 x SYSDIVSEL ) )
 */
#define F28M35H52C1_CFG_SYSDIVSEL_VAL                   ( 0x0 )     // Divide by 1

/*
 * See page 227 in the Concerto F28M28x TRM
 * M3SSCLK = ( ( ( OSCCLK x SYSPLLMULT ) / ( 2 x SYSDIVSEL ) ) / M3SSDIVSEL )
 */
#define F28M35H52C1_CFG_M3SSDIVSEL_VAL                  ( 0x1 )     // Divide by 2

/*
 * See page 227 in the Concerto F28M28x TRM
 */
#define F28M35H52C1_CFG_XPLLCLKCFG_VAL                  ( 0x0 )     // Turn OFF XPLLCLKOUT


/*
 * See page 223 in the Concerto F28M28x TRM
 */
#define F28M35H52C1_CFG_CCLKOFF_VAL                     ( 0x0 )     // C28 CPU CLKIN is turned ON

#ifdef __cplusplus
}
#endif

#endif /* __F28M35H52C1_CONFIG_H__ */
