/*
 * File: F28M35H52C1_M3MWRAllowCfgRegs.h
 */

#ifndef __F28M35H52C1_M3MWRALLOWCFGREGS_H__
#define __F28M35H52C1_M3MWRALLOWCFGREGS_H__

#include <stdint.h>

#ifdef __cplusplus
extern "C" {
#endif

#define MWR_ALLOW_KEY                       ( 0xA5A5A5A5 )


/*
 * M3 Configuration Write Allow (MWRALLOW) Register (Page 223 TRM)
 */
struct MWRALLOW_BITS {
    uint32_t ALLOW          :       32;
};

union MWRALLOW_REG {
    uint32_t    all;

    struct      MWRALLOW_BITS bit;
};


/*
 * M3 Configuration Lock (MLOCK) Register (Page 223 TRM)
 */
struct MLOCK_BITS {
    uint32_t MSxMSELLOCK    :       1;

    uint32_t RSVRD          :       31;
};

union MLOCK_REG {
    uint32_t    all;

    struct      MLOCK_BITS bit;
};


struct M3_MWRALLOW_CFG_REGS {
    union MWRALLOW_REG          MWRALLOW;

    union MLOCK_REG             MLOCK;
};

extern volatile struct M3_MWRALLOW_CFG_REGS M3MWRAllowCfgRegs;
#ifdef __cplusplus
}
#endif

#endif /* __F28M35H52C1_M3MWRALLOWCFGREGS_H__ */
