/*
 * File: F28M35H52C1_MToCIPCRegs.h
 */

#ifndef __F28M35H52C1_MTOCIPCREGS_H__
#define __F28M35H52C1_MTOCIPCREGS_H__

#include <stdint.h>

#ifdef __cplusplus
extern "C" {
#endif

#define NO_FLAG                     ( 0x00000000 )  // NO FLAG
#define IPC_FLAG1                   ( 0x00000001 )  // IPC FLAG 1
#define IPC_FLAG2                   ( 0x00000002 )  // IPC FLAG 2
#define IPC_FLAG3                   ( 0x00000004 )  // IPC FLAG 3
#define IPC_FLAG4                   ( 0x00000008 )  // IPC FLAG 4
#define IPC_FLAG5                   ( 0x00000010 )  // IPC FLAG 5
#define IPC_FLAG6                   ( 0x00000020 )  // IPC FLAG 6
#define IPC_FLAG7                   ( 0x00000040 )  // IPC FLAG 7
#define IPC_FLAG8                   ( 0x00000080 )  // IPC FLAG 8
#define IPC_FLAG9                   ( 0x00000100 )  // IPC FLAG 9
#define IPC_FLAG10                  ( 0x00000200 )  // IPC FLAG 10
#define IPC_FLAG11                  ( 0x00000400 )  // IPC FLAG 11
#define IPC_FLAG12                  ( 0x00000800 )  // IPC FLAG 12
#define IPC_FLAG13                  ( 0x00001000 )  // IPC FLAG 13
#define IPC_FLAG14                  ( 0x00002000 )  // IPC FLAG 14
#define IPC_FLAG15                  ( 0x00004000 )  // IPC FLAG 15
#define IPC_FLAG16                  ( 0x00008000 )  // IPC FLAG 16
#define IPC_FLAG17                  ( 0x00010000 )  // IPC FLAG 17
#define IPC_FLAG18                  ( 0x00020000 )  // IPC FLAG 18
#define IPC_FLAG19                  ( 0x00040000 )  // IPC FLAG 19
#define IPC_FLAG20                  ( 0x00080000 )  // IPC FLAG 20
#define IPC_FLAG21                  ( 0x00100000 )  // IPC FLAG 21
#define IPC_FLAG22                  ( 0x00200000 )  // IPC FLAG 22
#define IPC_FLAG23                  ( 0x00400000 )  // IPC FLAG 23
#define IPC_FLAG24                  ( 0x00800000 )  // IPC FLAG 24
#define IPC_FLAG25                  ( 0x01000000 )  // IPC FLAG 25
#define IPC_FLAG26                  ( 0x02000000 )  // IPC FLAG 26
#define IPC_FLAG27                  ( 0x04000000 )  // IPC FLAG 27
#define IPC_FLAG28                  ( 0x08000000 )  // IPC FLAG 28
#define IPC_FLAG29                  ( 0x10000000 )  // IPC FLAG 29
#define IPC_FLAG30                  ( 0x20000000 )  // IPC FLAG 30
#define IPC_FLAG31                  ( 0x40000000 )  // IPC FLAG 31
#define IPC_FLAG32                  ( 0x80000000 )  // IPC FLAG 32


//*****************************************************************************
// The following values report on the C28 boot ROM status at all times while
// the C28 is booting, and wil reside in CTOMBOOTSTS[15:0].
//*****************************************************************************
//invalid status - tells master system that the control system has not received
// a valid command.
#define CBROM_BOOTSTS_CTOM_IGNORE                                ( 0x00000000 )

//tells master system that control system has started to boot, but not
// completed the boot process yet
#define CBROM_BOOTSTS_CTOM_CONTROL_SYSTEM_START_BOOT             ( 0x00000001 )

//tells master system that control system has completed the boot and is running
#define CBROM_BOOTSTS_CTOM_CONTROL_SYSTEM_READY                  ( 0x00000002 )

//tells master system that C-BootROM ACKs the command in MTOCBOOTMODE register
#define CBROM_BOOTSTS_CTOM_BOOT_CMD_ACK                          ( 0x00000003 )

//tells master system that C-BootROM doesn't support the command in
// MTOCBOOTMODE register
#define CBROM_BOOTSTS_CTOM_BOOT_CMD_NAK_STATUS_NOT_SUPPORTED     ( 0x00000004 )

//tells master system that C-BootROM NAKs the current boot command in
// MTOCBOOTMODE register
#define CBROM_BOOTSTS_CTOM_BOOT_CMD_NAK_STATUS_BUSY_WITH_BOOT    ( 0x00000005 )


/*
 * Page 587 TRM
 */
#define MASTER_IPC_MTOC_COMMAND_ILLEGAL             ( 0x00000000 )

#define MASTER_IPC_MTOC_SET_BITS_16                 ( 0x00000001 )

#define MASTER_IPC_MTOC_SET_BITS_32                 ( 0x00000002 )

#define MASTER_IPC_MTOC_CLEAR_BITS_16               ( 0x00000003 )

#define MASTER_IPC_MTOC_CLEAR_BITS_32               ( 0x00000004 )

#define MASTER_IPC_MTOC_DATA_WRITE_16               ( 0x00000005 )

#define MASTER_IPC_MTOC_DATA_WRITE_32               ( 0x00000006 )

#define MASTER_IPC_MTOC_DATA_READ_16                ( 0x00000007 )

#define MASTER_IPC_MTOC_DATA_READ_32                ( 0x00000008 )

#define MASTER_IPC_MTOC_SET_BITS_PROTECTED_16       ( 0x00000009 )

#define MASTER_IPC_MTOC_SET_BITS_PROTECTED_32       ( 0x0000000A )

#define MASTER_IPC_MTOC_CLEAR_BITS_PROTECTED_16     ( 0x0000000B )

#define MASTER_IPC_MTOC_CLEAR_BITS_PROTECTED_32     ( 0x0000000C )

#define MASTER_IPC_MTOC_DATA_WRITE_PROTECTED_16     ( 0x0000000D )

#define MASTER_IPC_MTOC_DATA_WRITE_PROTECTED_32     ( 0x0000000E )

#define MASTER_IPC_MTOC_DATA_READ_PROTECTED_16      ( 0x0000000F )

#define MASTER_IPC_MTOC_DATA_READ_PROTECTED_32      ( 0x00000010 )

#define MASTER_IPC_MTOC_BRANCH_CALL                 ( 0x00000011 )

#define MASTER_IPC_MTOC_FUNCTION_CALL               ( 0x00000012 )

#define MASTER_IPC_MTOC_EXECUTE_BOOTMODE_CMD        ( 0x00000013 )


/*
 * Page 578 TRM
 */
#define IPC_MTOC_BOOT_FROM_RAM_MSG                  ( 0x00000001 )

#define IPC_MTOC_BOOT_FROM_FLASH_MSG                ( 0x00000002 )

#define IPC_MTOC_BOOT_FROM_SCI_MSG                  ( 0x00000003 )

#define IPC_MTOC_BOOT_FROM_SPI_MSG                  ( 0x00000004 )

#define IPC_MTOC_BOOT_FROM_I2C_MSG                  ( 0x00000005 )

#define IPC_MTOC_BOOT_FROM_PARALLEL_MSG             ( 0x00000006 )

/*
 * C28 to M3 Core IPC Acknowledge (CTOMIPCACK) Register, (Page 278 TRM)
 */
struct CTOMIPCACK_BITS
{
    uint32_t IPC1           :   1;

    uint32_t IPC2           :   1;

    uint32_t IPC3           :   1;

    uint32_t IPC4           :   1;

    uint32_t IPC5           :   1;

    uint32_t IPC6           :   1;

    uint32_t IPC7           :   1;

    uint32_t IPC8           :   1;

    uint32_t IPC9           :   1;

    uint32_t IPC10          :   1;

    uint32_t IPC11          :   1;

    uint32_t IPC12          :   1;

    uint32_t IPC13          :   1;

    uint32_t IPC14          :   1;

    uint32_t IPC15          :   1;

    uint32_t IPC16          :   1;

    uint32_t IPC17          :   1;

    uint32_t IPC18          :   1;

    uint32_t IPC19          :   1;

    uint32_t IPC20          :   1;

    uint32_t IPC21          :   1;

    uint32_t IPC22          :   1;

    uint32_t IPC23          :   1;

    uint32_t IPC24          :   1;

    uint32_t IPC25          :   1;

    uint32_t IPC26          :   1;

    uint32_t IPC27          :   1;

    uint32_t IPC28          :   1;

    uint32_t IPC29          :   1;

    uint32_t IPC30          :   1;

    uint32_t IPC31          :   1;

    uint32_t IPC32          :   1;
};


union CTOMIPCACK_REG
{
    uint32_t    all;

    struct      CTOMIPCACK_BITS bit;
};



/*
 * C28 to M3 Core IPC Status (CTOMIPCSTS) Register, (Page 280 TRM)
 */
struct CTOMIPCSTS_BITS
{
    uint32_t IPC1           :   1;

    uint32_t IPC2           :   1;

    uint32_t IPC3           :   1;

    uint32_t IPC4           :   1;

    uint32_t IPC5           :   1;

    uint32_t IPC6           :   1;

    uint32_t IPC7           :   1;

    uint32_t IPC8           :   1;

    uint32_t IPC9           :   1;

    uint32_t IPC10          :   1;

    uint32_t IPC11          :   1;

    uint32_t IPC12          :   1;

    uint32_t IPC13          :   1;

    uint32_t IPC14          :   1;

    uint32_t IPC15          :   1;

    uint32_t IPC16          :   1;

    uint32_t IPC17          :   1;

    uint32_t IPC18          :   1;

    uint32_t IPC19          :   1;

    uint32_t IPC20          :   1;

    uint32_t IPC21          :   1;

    uint32_t IPC22          :   1;

    uint32_t IPC23          :   1;

    uint32_t IPC24          :   1;

    uint32_t IPC25          :   1;

    uint32_t IPC26          :   1;

    uint32_t IPC27          :   1;

    uint32_t IPC28          :   1;

    uint32_t IPC29          :   1;

    uint32_t IPC30          :   1;

    uint32_t IPC31          :   1;

    uint32_t IPC32          :   1;
};


union CTOMIPCSTS_REG
{
    uint32_t    all;

    struct      CTOMIPCSTS_BITS bit;
};



/*
 * M3 to C28 IPC Set (MTOCIPCSET) Register, (Page 272 TRM)
 */
struct MTOCIPCSET_BITS
{
    uint32_t IPC1           :   1;

    uint32_t IPC2           :   1;

    uint32_t IPC3           :   1;

    uint32_t IPC4           :   1;

    uint32_t IPC5           :   1;

    uint32_t IPC6           :   1;

    uint32_t IPC7           :   1;

    uint32_t IPC8           :   1;

    uint32_t IPC9           :   1;

    uint32_t IPC10          :   1;

    uint32_t IPC11          :   1;

    uint32_t IPC12          :   1;

    uint32_t IPC13          :   1;

    uint32_t IPC14          :   1;

    uint32_t IPC15          :   1;

    uint32_t IPC16          :   1;

    uint32_t IPC17          :   1;

    uint32_t IPC18          :   1;

    uint32_t IPC19          :   1;

    uint32_t IPC20          :   1;

    uint32_t IPC21          :   1;

    uint32_t IPC22          :   1;

    uint32_t IPC23          :   1;

    uint32_t IPC24          :   1;

    uint32_t IPC25          :   1;

    uint32_t IPC26          :   1;

    uint32_t IPC27          :   1;

    uint32_t IPC28          :   1;

    uint32_t IPC29          :   1;

    uint32_t IPC30          :   1;

    uint32_t IPC31          :   1;

    uint32_t IPC32          :   1;
};


union MTOCIPCSET_REG
{
    uint32_t    all;

    struct      MTOCIPCSET_BITS bit;
};



/*
 * M3 to C28 IPC Clear (MTOCIPCCLR) Register, (Page 274 TRM)
 */
struct MTOCIPCCLR_BITS
{
    uint32_t IPC1           :   1;

    uint32_t IPC2           :   1;

    uint32_t IPC3           :   1;

    uint32_t IPC4           :   1;

    uint32_t IPC5           :   1;

    uint32_t IPC6           :   1;

    uint32_t IPC7           :   1;

    uint32_t IPC8           :   1;

    uint32_t IPC9           :   1;

    uint32_t IPC10          :   1;

    uint32_t IPC11          :   1;

    uint32_t IPC12          :   1;

    uint32_t IPC13          :   1;

    uint32_t IPC14          :   1;

    uint32_t IPC15          :   1;

    uint32_t IPC16          :   1;

    uint32_t IPC17          :   1;

    uint32_t IPC18          :   1;

    uint32_t IPC19          :   1;

    uint32_t IPC20          :   1;

    uint32_t IPC21          :   1;

    uint32_t IPC22          :   1;

    uint32_t IPC23          :   1;

    uint32_t IPC24          :   1;

    uint32_t IPC25          :   1;

    uint32_t IPC26          :   1;

    uint32_t IPC27          :   1;

    uint32_t IPC28          :   1;

    uint32_t IPC29          :   1;

    uint32_t IPC30          :   1;

    uint32_t IPC31          :   1;

    uint32_t IPC32          :   1;
};


union MTOCIPCCLR_REG
{
    uint32_t    all;

    struct      MTOCIPCCLR_BITS bit;
};



/*
 * M3 to C28 Core Flag (MTOCIPCFLG) Register, (Page 276 TRM)
 */
struct MTOCIPCFLG_BITS
{
    uint32_t IPC1           :   1;

    uint32_t IPC2           :   1;

    uint32_t IPC3           :   1;

    uint32_t IPC4           :   1;

    uint32_t IPC5           :   1;

    uint32_t IPC6           :   1;

    uint32_t IPC7           :   1;

    uint32_t IPC8           :   1;

    uint32_t IPC9           :   1;

    uint32_t IPC10          :   1;

    uint32_t IPC11          :   1;

    uint32_t IPC12          :   1;

    uint32_t IPC13          :   1;

    uint32_t IPC14          :   1;

    uint32_t IPC15          :   1;

    uint32_t IPC16          :   1;

    uint32_t IPC17          :   1;

    uint32_t IPC18          :   1;

    uint32_t IPC19          :   1;

    uint32_t IPC20          :   1;

    uint32_t IPC21          :   1;

    uint32_t IPC22          :   1;

    uint32_t IPC23          :   1;

    uint32_t IPC24          :   1;

    uint32_t IPC25          :   1;

    uint32_t IPC26          :   1;

    uint32_t IPC27          :   1;

    uint32_t IPC28          :   1;

    uint32_t IPC29          :   1;

    uint32_t IPC30          :   1;

    uint32_t IPC31          :   1;

    uint32_t IPC32          :   1;
};


union MTOCIPCFLG_REG
{
    uint32_t    all;

    struct      MTOCIPCFLG_BITS bit;
};



/*
 * MIPCCOUNTERL Register, (Page 295 TRM)
 */
struct MIPCCOUNTERL_BITS
{
    uint32_t COUNT          :   32;
};


union MIPCCOUNTERL_REG
{
    uint32_t    all;

    struct      MIPCCOUNTERL_BITS bit;
};



/*
 * MIPCCOUNTERH Register, (Page 295 TRM)
 */
struct MIPCCOUNTERH_BITS
{
    uint32_t COUNT          :   32;
};


union MIPCCOUNTERH_REG
{
    uint32_t    all;

    struct      MIPCCOUNTERL_BITS bit;
};



/*
 * CTOMIPCCOM Register, (Page 295 TRM)
 */
struct CTOMIPCCOM_BITS
{
    uint32_t COMMAND        :   32;
};


union CTOMIPCCOM_REG
{
    uint32_t    all;

    struct      CTOMIPCCOM_BITS bit;
};



/*
 * CTOMIPCADDR Register, (Page 295 TRM)
 */
struct CTOMIPCADDR_BITS
{
    uint32_t ADDR           :   32;
};


union CTOMIPCADDR_REG
{
    uint32_t    all;

    struct      CTOMIPCADDR_BITS bit;
};



/*
 * CTOMIPCDATAW Register, (Page 296 TRM)
 */
struct CTOMIPCDATAW_BITS
{
    uint32_t WDATA              :   32;
};


union CTOMIPCDATAW_REG
{
    uint32_t    all;

    struct      CTOMIPCDATAW_BITS bit;
};



/*
 * CTOMIPCDATAR Register, (Page 296 TRM)
 */
struct CTOMIPCDATAR_BITS
{
    uint32_t RDATA              :   32;
};


union CTOMIPCDATAR_REG
{
    uint32_t    all;

    struct      CTOMIPCDATAR_BITS bit;
};



/*
 * MTOCIPCCOM Register, (Page 296 TRM)
 */
struct MTOCIPCCOM_BITS
{
    uint32_t COMMAND        :   32;
};


union MTOCIPCCOM_REG
{
    uint32_t    all;

    struct      MTOCIPCCOM_BITS bit;
};



/*
 * MTOCIPCADDR Register, (Page 297 TRM)
 */
struct MTOCIPCADDR_BITS
{
    uint32_t ADDR           :   32;
};


union MTOCIPCADDR_REG
{
    uint32_t    all;

    struct      MTOCIPCADDR_BITS bit;
};



/*
 * MTOCIPCDATAW Register, (Page 297 TRM)
 */
struct MTOCIPCDATAW_BITS
{
    uint32_t WDATA              :   32;
};


union MTOCIPCDATAW_REG
{
    uint32_t    all;

    struct      MTOCIPCDATAW_BITS bit;
};



/*
 * MTOCIPCDATAR Register, (Page 297 TRM)
 */
struct MTOCIPCDATAR_BITS
{
    uint32_t RDATA              :   32;
};


union MTOCIPCDATAR_REG
{
    uint32_t    all;

    struct      MTOCIPCDATAR_BITS bit;
};



/*
 * CTOMIPCBOOTSTS Register, (Page 297 TRM)
 */
struct CTOMIPCBOOTSTS_BITS
{
    uint32_t BOOTSTS            :   32;
};


union CTOMIPCBOOTSTS_REG
{
    uint32_t    all;

    struct      CTOMIPCBOOTSTS_BITS bit;
};



/*
 * MTOCIPCBOOTMODE Register, (Page 298 TRM)
 */
struct MTOCIPCBOOTMODE_BITS
{
    uint32_t BOOTMODE           :   32;
};


union MTOCIPCBOOTMODE_REG
{
    uint32_t    all;

    struct      MTOCIPCBOOTMODE_BITS bit;
};



/*
 * MPUMPREQUEST Register, (Page 168 TRM)
 * MWRALLOW
 */
struct MPUMPREQUEST_BITS
{
    uint32_t REQUEST            :   32;
};


union MPUMPREQUEST_REG
{
    uint32_t    all;

    struct      MPUMPREQUEST_BITS bit;
};



/*
 * MCLKREQUEST Register, (Page 140 TRM)
 * MWRALLOW
 */
struct MCLKREQUEST_BITS
{
    uint32_t SEM                :   2;

    uint32_t RSVRD              :   30;
};


union MCLKREQUEST_REG
{
    uint32_t    all;

    struct      MCLKREQUEST_BITS bit;
};


/*
 * Master Subsystem IPC Registers (Page 176 TRM)
 */
struct MTOC_IPC_REGS
{
    union CTOMIPCACK_REG        CTOMIPCACK;

    union CTOMIPCSTS_REG        CTOMIPCSTS;

    union MTOCIPCSET_REG        MTOCIPCSET;

    union MTOCIPCCLR_REG        MTOCIPCCLR;

    union MTOCIPCFLG_REG        MTOCIPCFLG;

    uint32_t RSVRD1;

    union MIPCCOUNTERL_REG      MIPCCOUNTERL;

    union MIPCCOUNTERH_REG      MIPCCOUNTERH;

    union CTOMIPCCOM_REG        CTOMIPCCOM;

    union CTOMIPCADDR_REG       CTOMIPCADDR;

    union CTOMIPCDATAW_REG      CTOMIPCDATAW;

    union CTOMIPCDATAR_REG      CTOMIPCDATAR;

    union MTOCIPCCOM_REG        MTOCIPCCOM;

    union MTOCIPCADDR_REG       MTOCIPCADDR;

    union MTOCIPCDATAW_REG      MTOCIPCDATAW;

    union MTOCIPCDATAR_REG      MTOCIPCDATAR;

    union CTOMIPCBOOTSTS_REG    CTOMIPCBOOTSTS;

    union MTOCIPCBOOTMODE_REG   MTOCIPCBOOTMODE;

    union MPUMPREQUEST_REG      MPUMPREQUEST;

    union MCLKREQUEST_REG       MCLKREQUEST;

};


extern volatile struct MTOC_IPC_REGS    MTOCIPCRegs;

#ifdef __cplusplus
}
#endif

#endif /* __F28M35H52C1_MTOCIPCREGS_H__ */
