/*
 * File: F28M35H52C1_STRegs.h
 */

#ifndef __F28M35H52C1_STREGS_H__
#define __F28M35H52C1_STREGS_H__

#ifdef __cplusplus
extern "C" {
#endif

/*
 * SysTick Control and Status Register (STCTRL) (Page 1758 TRM)
 */
struct STCTRL_BITS {
    uint32_t ENABLE     :       1;

    uint32_t INTEN      :       1;

    uint32_t CLK_SRC    :       1;

    uint32_t RSVRD1     :       13;

    uint32_t COUNT      :       1;

    uint32_t RSVRD2     :       15;
};

union STCTRL_REG {
    uint32_t    all;

    struct      STCTRL_BITS bit;
};


/*
 * SysTick Reload Value Register (STRELOAD) (Page 1759 TRM)
 */
struct STRELOAD_BITS {
    uint32_t RELOAD     :       24;

    uint32_t RSVRD      :       8;
};

union STRELOAD_REG {
    uint32_t    all;

    struct      STRELOAD_BITS bit;
};


/*
 * SysTick Current Value Register (STCURRENT)  (Page 1759 TRM)
 */
struct STCURRENT_BITS {
    uint32_t CURRRENT   :       24;

    uint32_t RSVRD      :       8;
};

union STCURRENT_REG {
    uint32_t    all;

    struct      STCURRENT_BITS bit;
};



/*
 * SysTick (ST) Registers (Page 1755 TRM)
 */
struct ST_REGS
{
    union STCTRL_REG                         STCTRL;

    union STRELOAD_REG                       STRELOAD;

    union STCURRENT_REG                      STCURRENT;
};

extern volatile struct ST_REGS STRegs;

#ifdef __cplusplus
}
#endif

#endif /* __F28M35H52C1_STREGS_H__ */
