MEMORY
{
	PAGE 0:    /* Program Memory */

	PAGE 1:    /* Data Memory */

	GPTM0_REGS					: origin = 0x40030000, length = 0x000058     /* General Purpose Timer 0 Registers 	*/

	GPTM1_REGS					: origin = 0x40031000, length = 0x000058     /* General Purpose Timer 1 Registers 	*/

	GPTM2_REGS					: origin = 0x40032000, length = 0x000058     /* General Purpose Timer 2 Registers 	*/

	GPTM3_REGS					: origin = 0x40033000, length = 0x000058     /* General Purpose Timer 3 Registers 	*/

	USB0_REGS					: origin = 0x40050000, length = 0x000340     /* USB0 Registers 	*/

	GPIOA_REGS					: origin = 0x40058000, length = 0x000538    /* GPIOA Registers 	*/

	GPIOB_REGS					: origin = 0x40059000, length = 0x000538    /* GPIOB Registers 	*/

	GPIOC_REGS					: origin = 0x4005A000, length = 0x000538    /* GPIOC Registers 	*/

	GPIOD_REGS					: origin = 0x4005B000, length = 0x000538    /* GPIOD Registers 	*/

	GPIOE_REGS					: origin = 0x4005C000, length = 0x000538    /* GPIOE Registers 	*/

	GPIOF_REGS					: origin = 0x4005D000, length = 0x000538    /* GPIOF Registers 	*/

	GPIOG_REGS					: origin = 0x4005E000, length = 0x000538    /* GPIOG Registers 	*/

	GPIOH_REGS					: origin = 0x4005F000, length = 0x000538    /* GPIOH Registers 	*/

	GPIOJ_REGS					: origin = 0x40060000, length = 0x000538    /* GPIOJ Registers 	*/

	FLASH_CTL_REGS				: origin = 0x400FA000, length = 0x000304     /* Flash Conontrol Registers 			*/

	FLASH_ECC_ERROR_LOG_REGS	: origin = 0x400FA600, length = 0x000048     /* Flash ECC/Error Log Registers		*/

	MTOCIPC_REGS				: origin = 0x400FB700, length = 0x000050     /* Master Subsystem IPC Registers		*/

	CLK_CFG_REGS				: origin = 0x400FB800, length = 0x000078     /* Clock Configuration Registers 		*/

	M3_MWR_ALLOW_CFG_REGS		: origin = 0x400FB980, length = 0x000008     /* M3 MWRALLOW Configuration Registers */

	SYSCTL_REGS					: origin = 0x400FE000, length = 0x000198     /* M3 Device Identification and System Control Registers */

	ST_REGS						: origin = 0xE000E010, length = 0x00000C     /* SysTick (ST) Registers 				*/

	NV_REGS						: origin = 0xE000E100, length = 0x00035C     /* Nested Vectored Interrupt Controller (NVIC) Registers */

	SCB_REGS					: origin = 0xE000ED00, length = 0x00003C     /* System Control Block (SCB) Registers */

	SWTRIG_REGS					: origin = 0xE000EF00, length = 0x000004     /* Software Trigger Interrupt (SWTRIG) Register */
}

SECTIONS
{/*
	GPTM0RegsFile				: > GPTM0_REGS,					PAGE = 1

	GPTM1RegsFile				: > GPTM1_REGS,					PAGE = 1

	GPTM2RegsFile				: > GPTM2_REGS,					PAGE = 1

	GPTM3RegsFile				: > GPTM3_REGS,					PAGE = 1

	GPIOARegsFile				: > GPIOA_REGS,					PAGE = 1

	GPIOBRegsFile				: > GPIOB_REGS,					PAGE = 1

	GPIOCRegsFile				: > GPIOC_REGS,					PAGE = 1

	GPIODRegsFile				: > GPIOD_REGS,					PAGE = 1

	GPIOERegsFile				: > GPIOE_REGS,					PAGE = 1

	GPIOFRegsFile				: > GPIOF_REGS,					PAGE = 1

	GPIOGRegsFile				: > GPIOG_REGS,					PAGE = 1

	GPIOHRegsFile				: > GPIOH_REGS,					PAGE = 1

	GPIOJRegsFile				: > GPIOJ_REGS,					PAGE = 1
*/
	USB0RegsFile				: > USB0_REGS,					PAGE = 1

	FlashCtlRegsFile			: > FLASH_CTL_REGS,				PAGE = 1

	FlashECCErrorLogRegsFile	: > FLASH_ECC_ERROR_LOG_REGS,	PAGE = 1

	MTOCIPCRegsFile				: > MTOCIPC_REGS,				PAGE = 1

   	ClkCfgRegsFile        		: > CLK_CFG_REGS,     			PAGE = 1

   	M3MWRAllowCfgRegsFile		: > M3_MWR_ALLOW_CFG_REGS,		PAGE = 1

   	SysCtlRegsFile				: > SYSCTL_REGS,				PAGE = 1

   	STRegsFile					: > ST_REGS,					PAGE = 1

   	NVICRegsFile				: > NV_REGS,					PAGE = 1

   	SCBRegsFile					: > SCB_REGS,					PAGE = 1

   	SWTRIGRegFile				: > SWTRIG_REGS,				PAGE = 1
}
