/*
 * File: usb_msc.h
 */

#ifndef __USB_MSC_H__
#define __USB_MSC_H__


#ifdef __cplusplus
extern "C" {
#endif

#include "usb.h"



#define CBW_SIGNATURE                   ( 0x43425355 )
#define CSW_SIGNATURE                   ( 0x53425355 )


#define CBW_DATA_OUT_TRANSFER           ( 0x00 )
#define CBW_DATA_IN_TRANSFER            ( 0x80 )

typedef struct  __attribute__((packed))
{
    uint32_t    dCBWSignature;

    uint32_t    dCBWTag;

    uint32_t    dCBWDataTransferLength;

    uint8_t     bmCBWFlags;

    uint8_t     bCBWLUN;

    uint8_t     bCBWCBLength;

    uint8_t     CBWCB[16];

} CBW_STRUCT;



#define CSW_GOOD_STATUS                 ( 0x00 )
#define CSW_FAILED                      ( 0x01 )
#define CSW_PHASE_ERROR                 ( 0x02 )

typedef struct  __attribute__((packed))
{
    uint32_t    dCSWSignature;

    uint32_t    dCSWTag;

    uint32_t    dCSWDataResidue;

    uint8_t     bCSWStatus;

} CSW_STRUCT;


void usb_msc_process_cbw( void* pRcvMsg );


#ifdef __cplusplus
}
#endif  /* extern "C" */

#endif /* __USB_MSC_H__ */
