/*
 * File: usb_device.c
 */

#include <stdlib.h>

#include "F28M35H52C1_Device.h"

#include "usb_device.h"

static void USBEndPoint00INISR( void );

static void USBEndPoint00OUTISR( void );


#define USBEndPoint00INHandler              USBEndPoint00INISR

#define USBEndPoint00OUTHandler             USBEndPoint00OUTISR


static void ( *const pfnUSBEndPointINHandlers[] )( void ) =
{
#ifndef USBEndPoint00INHandler
    NULL,
#else
    USBEndPoint00INHandler,
#endif

#ifndef USBEndPoint01INHandler
    NULL,
#else
    USBEndPoint01INHandler,
#endif

#ifndef USBEndPoint02INHandler
    NULL,
#else
    USBEndPoint02INHandler,
#endif

#ifndef USBEndPoint03INHandler
    NULL,
#else
    USBEndPoint03INHandler,
#endif

#ifndef USBEndPoint04INHandler
    NULL,
#else
    USBEndPoint04INHandler,
#endif

#ifndef USBEndPoint05INHandler
    NULL,
#else
    USBEndPoint05INHandler,
#endif

#ifndef USBEndPoint06INHandler
    NULL,
#else
    USBEndPoint06INHandler,
#endif

#ifndef USBEndPoint07INHandler
    NULL,
#else
    USBEndPoint07INHandler,
#endif

#ifndef USBEndPoint08INHandler
    NULL,
#else
    USBEndPoint08INHandler,
#endif

#ifndef USBEndPoint09INHandler
    NULL,
#else
    USBEndPoint09INHandler,
#endif

#ifndef USBEndPoint10INHandler
    NULL,
#else
    USBEndPoint10INHandler,
#endif

#ifndef USBEndPoint11INHandler
    NULL,
#else
    USBEndPoint11INHandler,
#endif

#ifndef USBEndPoint12INHandler
    NULL,
#else
    USBEndPoint12INHandler,
#endif

#ifndef USBEndPoint13INHandler
    NULL,
#else
    USBEndPoint13INHandler,
#endif

#ifndef USBEndPoint14INHandler
    NULL,
#else
    USBEndPoint14INHandler,
#endif

#ifndef USBEndPoint15INHandler
    NULL,
#else
    USBEndPoint15INHandler,
#endif
};


static void ( *const pfnUSBEndPointOUTHandlers[] )( void ) =
{
#ifndef USBEndPoint00OUTHandler
    NULL,
#else
    USBEndPoint00OUTHandler,
#endif

#ifndef USBEndPoint01OUTHandler
    NULL,
#else
    USBEndPoint01OUTHandler,
#endif

#ifndef USBEndPoint02OUTHandler
    NULL,
#else
    USBEndPoint02OUTHandler,
#endif

#ifndef USBEndPoint03OUTHandler
    NULL,
#else
    USBEndPoint03OUTHandler,
#endif

#ifndef USBEndPoint04OUTHandler
    NULL,
#else
    USBEndPoint04OUTHandler,
#endif

#ifndef USBEndPoint05OUTHandler
    NULL,
#else
    USBEndPoint05OUTHandler,
#endif

#ifndef USBEndPoint06OUTHandler
    NULL,
#else
    USBEndPoint06OUTHandler,
#endif

#ifndef USBEndPoint07OUTHandler
    NULL,
#else
    USBEndPoint07OUTHandler,
#endif

#ifndef USBEndPoint08OUTHandler
    NULL,
#else
    USBEndPoint08OUTHandler,
#endif

#ifndef USBEndPoint09OUTHandler
    NULL,
#else
    USBEndPoint09OUTHandler,
#endif

#ifndef USBEndPoint10OUTHandler
    NULL,
#else
    USBEndPoint10OUTHandler,
#endif

#ifndef USBEndPoint11OUTHandler
    NULL,
#else
    USBEndPoint11OUTHandler,
#endif

#ifndef USBEndPoint12OUTHandler
    NULL,
#else
    USBEndPoint12OUTHandler,
#endif

#ifndef USBEndPoint13OUTHandler
    NULL,
#else
    USBEndPoint13OUTHandler,
#endif

#ifndef USBEndPoint14OUTHandler
    NULL,
#else
    USBEndPoint14OUTHandler,
#endif

#ifndef USBEndPoint15OUTHandler
    NULL,
#else
    USBEndPoint15OUTHandler,
#endif
};

uint8_t u8DeviceAddress                 = 0;

uint8_t u8DeviceConfiguration           = 0;

USE_DEVICE_STATE_ENUM USBDeviceState    = USB_DISCONNECTED_STATE;

volatile CONTROL_TRANSFER_CTLBLK_STRUCT ControlPacket = {

    .PHASE                      = USB_CONTROL_TRANSFER_IDLE_PHASE,

    .u8AssignedPendingAddress   = 0,
};


static int16_t USBReadEndPoint0Data( uint8_t* pdst, uint16_t offset )
{
    int16_t i16Len, i16Idx;

    uint8_t* psrc;

    i16Len              = -1;

    psrc                = NULL;

    if( USB0Regs.USBCSRL0.bitD.RXRDY != 0 )
    {
        i16Len = ( USB0Regs.USBCOUNT0.bit.COUNT & 0x7F );

        psrc = ( ( uint8_t* )( &( USB0Regs.USBFIFO0.all ) ) );

        pdst += offset;

        for( i16Idx = 0; i16Idx < i16Len; i16Idx++ ) { *pdst++ = *psrc++; }
    }

    return ( i16Len );
}


void USBWriteEndPoint0Data( void )
{
    uint16_t u16LenToWrite, u16Idx;

    uint8_t* pdst;
    uint8_t* psrc;

    uint8_t u8CtlByte;

    if( USB0Regs.USBCSRL0.bitD.TXRDY == 0 )
    {
        if( ControlPacket.u16TransferredLen >= ControlPacket.u16RequestLen )
        {
            // Stall endpoint 0.
        }
        else
        {
            if( ControlPacket.u16TransferredLen <= ControlPacket.u16PayloadLen )
            {
                pdst = ( ( uint8_t* )( &( USB0Regs.USBFIFO0.all ) ) );

                psrc = ( ( uint8_t* )( &( ControlPacket.RxTxBuf[ControlPacket.u16TransferredLen ] ) ) );

                u16LenToWrite = ( ControlPacket.u16PayloadLen - ControlPacket.u16TransferredLen );

                if( ( u16LenToWrite + ControlPacket.u16TransferredLen ) > ControlPacket.u16RequestLen )
                {
                    u16LenToWrite = ( ControlPacket.u16RequestLen - ControlPacket.u16TransferredLen );
                }

                u16LenToWrite = ( ( u16LenToWrite > 64 ) ? 64 : u16LenToWrite );

                for( u16Idx = 0; u16Idx < u16LenToWrite; u16Idx++ ) { *pdst++ = *psrc++; }

                ControlPacket.u16TransferredLen += u16LenToWrite;
            }

            u8CtlByte           = 0x82;

            ControlPacket.PHASE = USB_CONTROL_TRANSFER_DATA_IN_PHASE;

            if( ( ControlPacket.u16TransferredLen == ControlPacket.u16PayloadLen ) ||
                ( ControlPacket.u16TransferredLen == ControlPacket.u16RequestLen ) )
            {
                if( ( ControlPacket.u16TransferredLen >= ControlPacket.u16RequestLen ) ||
                    ( u16LenToWrite == 0 ) )
                {
                    u8CtlByte |= 0x08;

                    ControlPacket.PHASE = USB_CONTROL_TRANSFER_IDLE_PHASE;
                }
            }

            USB0Regs.USBCSRL0.bitD.STALLED   = 0;
            USB0Regs.USBCSRL0.all           |= u8CtlByte;
        }
    }
}



static void USBEndPoint00INISR( void )
{
    switch( ControlPacket.PHASE )
    {
        case USB_CONTROL_TRANSFER_IDLE_PHASE:
        {
            //TODO: Stall Endpoint 0 OUT.

            break;
        }
        case USB_CONTROL_TRANSFER_DATA_IN_PHASE:
        {
            USBWriteEndPoint0Data( );

            break;
        }
    }
}


static void USBEndPoint00OUTISR( void )
{
    uint8_t u8CtlByte;
    uint16_t i16Len;

    switch( ControlPacket.PHASE )
    {
        case USB_CONTROL_TRANSFER_IDLE_PHASE:
        {
            i16Len = USBReadEndPoint0Data( ( ( uint8_t*)( &( ControlPacket.RxTxBuf ) ) ),
                                           0 );

            if( i16Len > 0 ) { usb_control_packet_process(); }

            break;
        }
        case USB_CONTROL_TRANSFER_DATA_OUT_PAHSE:
        {
            if( ControlPacket.u16TransferredLen < ControlPacket.u16RequestLen )
            {
                i16Len = USBReadEndPoint0Data( ( ( uint8_t* )( ControlPacket.RxTxBuf ) ),
                                                ControlPacket.u16TransferredLen );

                if( i16Len >= 0 ) { ControlPacket.u16TransferredLen += i16Len; }

                u8CtlByte = 0x4;

                if( ControlPacket.u16TransferredLen >= ControlPacket.u16RequestLen ) { u8CtlByte |= 0x08; }

                USB0Regs.USBCSRL0.all |= u8CtlByte;
            }
            else
            {
                //TODO: Stall Endpoint 0 OUT.
            }

            break;
        }
    }
}


static void USBDeviceReset( void )
{
    u8DeviceAddress         =   0;

    USBDeviceState          =   USB_DEFAULT_STATE;

    u8DeviceConfiguration   =   0;
}


static void USBDeviceInterrupt()
{
    if( USB0Regs.USBIE.bitD.DISCON )
    {
        // Handle Disconnect
        USBDeviceState = USB_DISCONNECTED_STATE;
    }

    if( USB0Regs.USBIE.bitD.RESET )
    {
        // Handle Reset
        USBDeviceReset();
    }

    if( USB0Regs.USBIE.bitD.RESUME )
    {
        // Handle Resume
        USBDeviceState = USB_CONFIGURED_STATE;
    }

    if( USB0Regs.USBIE.bitD.SUSPEND )
    {
        // Handle Suspend
        USBDeviceState = USB_SUSPEND_STATE;
    }
}


static void USBDeviceINTransfer( void )
{
    uint16_t u16Idx, u16Bit;

    if( USB0Regs.USBTXIS.all != 0 )
    {
        // Handle IN Transfer
        u16Idx = 1;

        for( u16Idx = 0; u16Idx < 15; u16Idx++ )
        {

            if( USB0Regs.USBTXIS.all &  u16Bit )
            {
                if( pfnUSBEndPointINHandlers[ u16Idx ] != NULL )
                {
                    pfnUSBEndPointINHandlers[ u16Idx ]();
                }
            }

            u16Bit <<= 1;
        }
    }
}


static void USBDeviceOUTTransfer( void )
{
    uint16_t u16Idx, u16Bit;

    if( USB0Regs.USBRXIS.all != 0 )
    {
        // Handle OUT Transfer
        u16Idx = 1;

        for( u16Idx = 0; u16Idx < 15; u16Idx++ )
        {
            if( USB0Regs.USBRXIS.all &  u16Bit )
            {
                if( pfnUSBEndPointOUTHandlers[ u16Idx ] != NULL )
                {
                    pfnUSBEndPointOUTHandlers[ u16Idx ]();
                }
            }

            u16Bit <<= 1;
        }
    }
}


void Usb0ISR( void )
{
    USBDeviceInterrupt();

    USBDeviceOUTTransfer();

    USBDeviceINTransfer();
}

