/*
 * File: usb_device.h
 */

#ifndef __USB_DEVICE_H__
#define __USB_DEVICE_H__

#include <stdbool.h>
#include <stdint.h>

#ifdef __cplusplus
extern "C" {
#endif

#include "usb.h"


typedef enum
{
    USB_CONTROL_TRANSFER_IDLE_PHASE,

    USB_CONTROL_TRANSFER_DATA_IN_PHASE,

    USB_CONTROL_TRANSFER_DATA_OUT_PAHSE,

    USB_CONTROL_TRANSFER_STATUS_PHASE,

    USB_CONTROL_TRANSFER_STALL_PHASE,

} USP_CONTROL_TRANSFER_PHASE_ENUM;


typedef struct __attribute__((packed))
{
    USP_CONTROL_TRANSFER_PHASE_ENUM PHASE;

    uint8_t u8AssignedPendingAddress;

    uint8_t u16TransferredLen;

    uint16_t RSVRD;

    uint16_t u16PayloadLen;

    uint16_t u16RequestLen;

    uint8_t RxTxBuf[256];

} CONTROL_TRANSFER_CTLBLK_STRUCT;


extern USB_DEVICE_DESCRIPTOR_STRUCT USB_DEVICE_DEVICE_DESC;

extern USB_CONFIGURATION_DESCRIPTOR_STRUCT USB_DEVICE_CONFIGURATION_DESCs[];

extern USB_INTERFACE_DESCRIPTOR_STRUCT USB_DEVICE_INTERFACE_DESCs[];

extern USB_ENDPOINT_DESCRIPTOR_STRUCT USB_DEVICE_ENDPOINT_DESCs[];

extern USE_DEVICE_STATE_ENUM USBDeviceState;

extern uint8_t u8DeviceAddress;

extern uint8_t u8DeviceConfiguration;

extern volatile CONTROL_TRANSFER_CTLBLK_STRUCT ControlPacket;

void USBWriteEndPoint0Data( void );

#ifdef __cplusplus
}
#endif  /* extern "C" */

#endif /* __USB_DEVICE_H__ */
