/*
 * File: flashctl.c
 */
#include "../../F28M35H52C1M_headers/include/F28M35H52C1_Device.h"

//RAM Function Linker Section
#pragma CODE_SECTION(flashctl_init, "ramfuncs");
void flashctl_init( void )
{
    uint32_t u32MWRAllow;

    uint32_t i;

    u32MWRAllow = M3MWRAllowCfgRegs.MWRALLOW.all;

    M3MWRAllowCfgRegs.MWRALLOW.all  = MWR_ALLOW_KEY;

    // Power up Flash bank and pump; this also sets the fall back mode of
    // flash and pump as active
    FlashCtlRegs.FPAC1.bit.PMPPWR                   = 1;

    FlashCtlRegs.FBFALLBACK.bit.BNKPWR              = 3;

    //Disable Cache and pre-fetch mechanism before changing wait states
    FlashCtlRegs.FRD_INTF_CTRL.all                  = 0;

    // Set wait states according to frequency
    //                CAUTION
    // Minimum wait states required for the flash operating
    // at a given CPU rate must be characterized by TI.
    // Refer to the data sheet for the latest information.
    FlashCtlRegs.FRDCNTL.bit.RWAIT                  = 2;

    // Enable Cache and pre-fetch mechanism to improve performance
    // of code executed from Flash.
    FlashCtlRegs.FRD_INTF_CTRL.bit.PROG_CACHE_EN    = 1;

    FlashCtlRegs.FRD_INTF_CTRL.bit.DATA_CATCHE_EN   = 1;

    FlashECCErrorLogRegs.ECC_ENABLE.bit.ENABLE      = 0xA;

    M3MWRAllowCfgRegs.MWRALLOW.all = u32MWRAllow;

    // Force a pipeline flush to ensure that the write to
    // the last register configured occurs before returning.
    for( i = 0; i < 7; i++ ) { __asm(" NOP"); }
}
