/*
 * File: gpio.c
 */

#include "../../F28M35H52C1M_headers/include/F28M35H52C1_Device.h"

#include "gpio.h"

#define GPIO_UNLOCK                     ( 0x4C4F434B )

void gpio_init( void )
{
    volatile struct GPIO_REGS* pRegs;

    uint32_t u32MWRAllow;

    u32MWRAllow                     = M3MWRAllowCfgRegs.MWRALLOW.all;

    M3MWRAllowCfgRegs.MWRALLOW.all  = MWR_ALLOW_KEY;

    SysCtlRegs.GPIOHBCTL.bit.PORTC  = 1;    // Advanced High-Performance Bus (AHB)

    pRegs = ( ( volatile struct GPIO_REGS* )( 0x4005A000 ) );



    pRegs->GPIODATA.bit.PIN7 = 0;

    //GPIOCRegs.GPIODATA.bit.PIN7 = 0;

    //GPIOCRegs.GPIOLOCK.all      = GPIO_UNLOCK;

    // Set up the Pin for LED LD3 [PORTC GPIO PIN 7 OUTPUT] (GPIO71)
    //GPIOCRegs.GPIODIR.bit.PIN7 = GPIO_OUTPUT_DIR;

    //GPIOCRegs.GPIODEN.bit.PIN7 = GPIO_DIGITAL_FUNC_ENABLED;

    pRegs->GPIOLOCK.all             = GPIO_UNLOCK;

    pRegs->GPIODIR.bit.PIN7         = GPIO_OUTPUT_DIR;

    pRegs->GPIODEN.bit.PIN7         = GPIO_DIGITAL_FUNC_ENABLED;

    // Give C28 control of Port C pin 6 (GPIO70)
    pRegs->GPIOCSEL.bit.CSEL6 = C28_GPIO_CORE_SELECT;

    M3MWRAllowCfgRegs.MWRALLOW.all  = u32MWRAllow;
}
