/*
 * File: psp_utils.c
 */
#include <stdint.h>

#include "../../F28M35H52C1M_headers/include/F28M35H52C1_Device.h"

#include "psp_utils.h"


static uint32_t u32MWRAllow;

static uint32_t u32MWRAllowCntr = 0;

void psp_utils_enter_privilige_mode( void )
{
    if( u32MWRAllowCntr == 0 )
    {
        u32MWRAllow = M3MWRAllowCfgRegs.MWRALLOW.all;
    }

    M3MWRAllowCfgRegs.MWRALLOW.all  = MWR_ALLOW_KEY;

    u32MWRAllowCntr++;
}


void psp_utils_exit_privilige_mode( void )
{
    if( u32MWRAllowCntr > 0 ) { u32MWRAllowCntr--; }

    if( u32MWRAllowCntr == 0 )
    {
        M3MWRAllowCfgRegs.MWRALLOW.all  = u32MWRAllow;
    }
}
